import objectdraw.*;
import java.awt.*;

public class Spotty extends FrameWindowController implements ClientListener {
	Client network;
		
	public void begin() {
		Network.configure("Spotty", ServerListener.ECHO, this);
	}
	
	public String encodeLocation(Location point) {
		String x = Integer.toString(point.getX());
		String y = Integer.toString(point.getY());
		return x + "," + y;
	}
	
	public Location decodeLocation(String message) {
		int pos = message.indexOf(",");
		int x = Integer.parseInt(message.substring(0, pos));
		int y = Integer.parseInt(message.substring(pos + 1));
		return new Location(x, y);
	}

	public void onMousePress(Location point) {
		network.sendMessage(encodeLocation(point));
	}

	public void messageReceived(Client client, String message) {
		Location point = decodeLocation(message);
		point.translate(-5, -5);
		new FilledOval(point, 10, 10, canvas);
	}

	public void clientConnected(Client client) {
		network = client;
	}

	public void clientDisconnected(Client client) {
	}

	public static void main(String[] args) {
		new Spotty();
	}
}
