class Particle {
	int x;
	int y;
	int vx;
	int vy;
	int size;
	int owner;
	
	public Particle(int x, int y, int vx, int vy, int size, int owner) {
		this.x = x;
		this.y = y;
		this.vx = vx;
		this.vy = vy;
		this.size = size;
		this.owner = owner;
	}
	
	public boolean outOfBounds() {
		return x < 0 || x >= 600 || y < 0 || y >= 600;
	}
	
	public void update() {
		x += vx;
		y += vy;
	}
	
	public boolean collided(Particle other) {
		if(other.owner == owner) return false;
		
		int dx = other.x - x;
		int dy = other.y - y;
		int r = other.size + size;
		
		return dx * dx + dy * dy < r * r;
	}
	
	public String encode() {
		return x + "," + y + ";" + size + "," + owner;
	}
}