import java.util.LinkedList;
import objectdraw.Location;

public class Snake {
	LinkedList<Location> segments;
	int growth;
	int dx;
	int dy;
	
	public Snake(int x, int y, int dx, int dy) {
		this.dx = dx;
		this.dy = dy;
		growth = 0;
		
		segments = new LinkedList<Location>();
		for(int i = 0; i < 20; i++) {
			segments.addLast(new Location(x, y));
			x += dx;
			y += dy;
		}
	}
	
	public void turnLeft() {
		int temp = dx;
		dx = dy;
		dy = -temp;
	}
	
	public void turnRight() {
		int temp = dx;
		dx = -dy;
		dy = temp;
	}
	
	public void update(SnakesServer server) {
		if(segments.isEmpty()) return;
		
		if(growth > 0) {
			growth = growth - 1;
		} else {
			segments.removeFirst();
		}
		
		if(growth < 0) return;
		
		Location head = segments.getLast();
		Location newHead = head.offset(dx, dy);
		
		if(server.hitFood(newHead, true)) growth = growth + 10;
		
		if(server.hitSnakeOrWall(newHead)) {
			growth = -1;
		} else {
			segments.addLast(newHead);
		}
	}
	
	public String encode() {
		String message = "";
		for(Location s : segments) {
			message += Code.encodeLocation(s) + ";";
		}
		return message;
	}
	
	public boolean contains(Location loc) {
		for(Location s : segments) {
			if(s.equals(loc)) return true;
		}
		return false;
	}
}
