import objectdraw.*;
import java.awt.*;

public class SpaceWarsClient extends FrameWindowController implements ClientListener {
	Client network;
	
	public SpaceWarsClient() {
		super(600, 600, "SpaceWars");
		canvas.setBackground(Color.BLACK);
		Network.configure("SpaceWars", new SpaceWarsServer(), this);
	}
	
	public void onOtherPress(String key) {
		if(network != null) network.sendMessage(key + "Press");
	}
	
	public void onOtherRelease(String key) {
		if(network != null) network.sendMessage(key + "Release");
	}

	public void clientConnected(Client client) {
		network = client;
	}

	public void clientDisconnected(Client client) {
		network = null;
	}
	
	public void decode(String message) {
		int pos = message.indexOf(";");
		
		Location center = Code.decodeLocation(message.substring(0, pos));
		
		Location other = Code.decodeLocation(message.substring(pos + 1));
		int size = other.getX();
		int team = other.getY();
		
		Color color = Color.getHSBColor((.618034f * team) % 1, 1f, 1f);
		
		center.translate(-size, -size);
		new FilledOval(center, size * 2, size * 2, color, canvas);
	}

	public void messageReceived(Client client, String message) {
		canvas.clear();
		
		for(String part : message.split("\n")) {
			decode(part);
		}
	}

	public static void main(String[] args) {
		new SpaceWarsClient();
	}
}
